SuperStrict

AppTitle = "SnailRace - BCC#75"
Global gfx_w:Int = 850
Global gfx_h:Int = 450
Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(59)

Global mx:Int, my:Int, mkl:Int=4, mh:Int[mkl], md:Int[mkl], md_timer:Int[mkl], key:Int[256], ms:Int

SetImageFont(LoadImageFont(getenv_("windir") + "/fonts/" + "Arial.ttf", 22))

Global bg_img:TImage = Loadimage("data/gfx.png") 
Global line_img:TImage = Loadimage("data/line.png") 
Global field_img:TImage = Loadimage("data/field.png") 
Global snail_img:TImage = LoadAnimimage("data/snails.png", 97, 52, 0, 5) 
Global go_img:TImage = LoadAnimimage("data/go.png", 64, 64, 0, 3) 
Global cs_img:TImage = LoadAnimimage("data/cs.png", 48, 40, 0, 5) 
Global salat_img:TImage = LoadAnimimage("data/salat.png", 48, 48, 0, 3) 
Global salatbut_img:TImage = LoadAnimimage("data/salbut.png", 48, 48, 0, 2) 
Global buysalat_img:TImage = Loadimage("data/buysalat.png") 
SetImageHandle(snail_img, 92, 26)

Global SnailNames:String[] = LoadString("data/names.txt").split("~n")
Global snails:TSnail[5] 
For Local i:Int = 0 Until snails.length
	snails[i] = TSnail.Create( 50+ i * 60, i )
Next


Global Money:Int = 1000
Global Select_Snail:Int = 0
Global Select_Place:Int = 1
Global Select_Money:Int = 0
Global WinMoney:Int = 0
Global SalatCount:Int = 3, SalatUsed:Int = 0

SetColor(0, 0, 0)
SetClsColor(255, 255, 255)
SetBlend(ALPHABLEND)

Repeat
	Cls
	
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()

	For Local i:Int = 1 Until mkl
		mh[i] = MouseHit(i)
		if mh[i] then md_timer[i] = ms + 250
		if (md_timer[i] < ms) then
			md_timer[i] = ms + 250
			md[i] = MouseDown(i)
		Else
			md[i] = 0
		endif
	Next
	For Local i:Int = 0 Until key.length
		key[i] = KeyHit(i)
	Next

	SetColor(255, 255, 255)
	DrawImage(line_img, TSnail.x_end, 180)
	TSnail.UpdateALL()
	DrawImage(bg_img, gfx_w*.5, 400)

	DrawImage(field_img, gfx_w*.5, gfx_h*.93-38)
	DrawImage(field_img, gfx_w*.5, gfx_h*.93)

	DrawImage(cs_img, 540, gfx_h*.93-38, Select_Snail)

	if (TSnail.running=true OR Select_Money=0) then
		DrawImage(go_img, gfx_w-48, gfx_h-48, 2)
	Else
		if ButtonImg(go_img, 0, gfx_w-48, gfx_h-48) then TSnail.running=true
	endif

	if (TSnail.running=false) then
		'* Snail
		Select Btn(290, 365, 270, 30)
			Case 1;
				Select_Snail = (Select_Snail+1) mod 5
			Case 2;
				Select_Snail = (Select_Snail+4) mod 5
		EndSelect
		
		'* Place
		if (Btn(520, gfx_h*.93-15, 40, 30)) then 
			Select_Place :+1
			if Select_Place > 5 then Select_Place=1
		endif

		'* Money
		Select Btn(290, 405, 220, 30)
			Case 1;
				MoneyTrans( -5 )
			Case 2;
				MoneyTrans( 5 )
		EndSelect
	endif

	if (TSnail.running=false OR SalatUsed=true OR SalatCount=0) then
		DrawImage(salat_img,gfx_w*.78, gfx_h-48, 2)
	Else
		if ButtonImg(salat_img, 0, gfx_w*.78, gfx_h-48) then
			SalatCount:-1
			SalatUsed=true
		endif
		if (mouseInRect(gfx_w*.80-40, gfx_h-72, 48, 48)) then
			SetColor(0,0,0);
			DrawText("Salat Blatt benutzen!", gfx_w*.5, gfx_h*.74)
		endif
	endif
	SetColor(0,0,0); setScale(0.5,0.5)
	DrawText(SalatCount, gfx_w*.80, gfx_h-34, 1)
	setScale(1,1)


	SetColor(255,255,255)
	if ButtonImg(salatbut_img, 0, gfx_w*.84, gfx_h-48) then
		setAlpha(0.7)
		SetColor(0,0,0)
			Drawrect(0,0,gfx_w,gfx_h)
		setAlpha(1)	
		SetColor(255,255,255)
			DrawImage(buysalat_img,gfx_w*.5,gfx_h*.4)
		flip()
		waitmouse()
	endif

	SetColor(0, 0, 0)
	'DrawText(mx+", "+my+" - "+md[1], 15, 15, 0)
	'DrawText((md_timer[1] - ms), 15, 15, 0)

	DrawText(Money, 150, 378, 1)
	DrawText(WinMoney, 150, 425, 1)
	DrawText(snails[Select_Snail].name, 500, gfx_h*.93-38, 1)
	DrawText("1:5", 540, gfx_h*.93-38)
	DrawText(Select_Money, 500, gfx_h*.93, 1)
	DrawText(Select_Place, 540, gfx_h*.93)

	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End 

Function MoneyTrans(_c:Int)

	'* Auszahlen
	if _c < 0 then
		_c = abs(_c)
		if (Money < _c) then return
		Money :- _c
		Select_Money :+ _c
	'* Einzahlen
	ElseIf _c > 0 then
		if (Select_Money < _c) then return
		Select_Money :- _c
		Money :+ _c
	EndIf

	WinMoney = Select_Money*5

EndFunction

Function DrawText(txt:String, X:Float, Y:Float, HX:Float = 0.5, HY:Float = 0.5)
	Local scale_X:Float, scale_Y:Float
	GetScale(scale_X, scale_Y)
	brl.max2d.DrawText(txt, Int(X - (Float(TextWidth(txt)) * scale_X * HX)), Int(Y - (Float(TextHeight(txt)) * scale_Y * HY)))
End Function

Function ButtonImg:Int(_img:TImage, _frame:Int, _x:Int, _y:Int)
	Local re:Int = 0
	If mouseInRect(_x - _img.width / 2, _y - _img.height / 2, _img.width, _img.height)
		DrawImage(_img, _x, _y, _frame + 1)
		If mh[1] = True Then re = 1
	Else
		DrawImage(_img, _x, _y, _frame)
	EndIf
	Return re
End Function

Function Btn:Int (_x:Int, _y:Int, _w:Int, _h:Int)
	Local result:Int=0
	'Drawrect(_x,_y,_w,_h)
	If mouseInRect(_x, _y, _w, _h) then
		If mh[1] OR md[1] Then result = 1
		If mh[2] OR md[2] Then result = 2		
	endif	
	return result
EndFunction

Function mouseInRect:Int(x:Int, y:Int, w:Int, h:Int)
	If mx <= x Then Return False
	If my <= y Then Return False
	If mx >= x + w Then Return False
	If my >= y + h Then Return False
	Return True	
End Function

Function FetchName:String()
	Local i:Int = Rand(0, SnailNames.length - 1)
	Local s:String = SnailNames[i]
	SnailNames = SnailNames[..i] + SnailNames[i + 1..]
	return s
EndFunction

Type TSnail 
	Field x:Float, y:Float
	Field speed:Float
	Field sp_timer:Int = -1
	Field frame:Int
	Field win:Int, loss:Int, place:Int = 0
	Field name:String = ""

	Const x_start:Int = 120
	Const x_end:Int = 805
	Global running:Int = false
	Global speed_min:Float = 0.001
	Global speed_max:Float = 0.200
	Global P:Int = 1
	Global RestartTime:Int = 0
	Global list:Tlist = new Tlist

	Function Create:TSnail( _y:Float, _frame:Int )
		Local o:TSnail = new TSnail
			o.name = FetchName()
			o.x = x_start
			o.y = _y
			o.frame = _frame
			list.addLast(o)
		return o
	EndFunction

	Function UpdateALL()
		For Local o:TSnail = EachIn TSnail.list
			o.Draw()
			if (running) Then o.Update()
		Next		

		if (TSnail.P = 6) then 
			RestartTime = ms + 3500
			if (snails[Select_Snail].place = Select_Place) then
				Money:+WinMoney
			endif
			Select_Money = 0
			WinMoney = 0
			TSnail.P = 1
		endif

		if (RestartTime>0 AND RestartTime < ms) then
			RestartTime = 0
			running = false
			SalatUsed = false
			For Local o:TSnail = EachIn TSnail.list
				o.Reset()
			Next
		endif

		For Local o:TSnail = EachIn TSnail.list
			if (mouseInRect(o.x-95,o.y-25,97,52)) then
				SetColor(0,0,0)
				DrawText(o.name, gfx_w*.5, gfx_h*.74)
				SetColor(255,255,255)
			endif
		next
	EndFunction

	Method Update()

		if (sp_timer < ms) Then
			sp_timer = ms + rand(2,6)*500
			speed = rnd(speed_min, speed_max)
			if (SalatUsed=true) then 
				speed = (speed_min+speed_max)/2
				if (snails[Select_Snail] = self) then speed = speed_max*2.0
				if (snails[Select_Snail].place>0) then speed = speed_max
			endif
		endif

		x:+speed
		if (x >= x_end AND place = 0) Then 
			place = TSnail.P
			TSnail.P :+ 1
		endif

	EndMethod

	Method Draw()
		DrawImage(snail_img, x, y, frame)
		if (place>0) then 
			DrawImage(cs_img, gfx_w-90, y, frame)
			SetColor(0,0,0)
			DrawText(place, gfx_w-90, y)
			SetColor(255,255,255)
		endif
	EndMethod

	Method Reset()
		place = 0
		x = x_start
		sp_timer = -1
	EndMethod

EndType
